<template>
    <div class="container">
        <div class="row">
        <CCol sm="6" md="4" v-for="salle in salles" :key="salle.libelle">
        <CCard>
          <CCardHeader>
            {{salle.libelle}}
            
            <div class="card-header-actions">
            </div>
            <CBadge shape="pill" color="danger" class="float-right">Capacité : {{salle.capacite}}</CBadge>
          </CCardHeader>
          <CCardBody>
            {{salle.emplacement}}
            <footer style="float:right">
                <CLink href="#" class="card-header-action btn-setting" @click="modalEdit=true; sendInfoSalle(salle)" >
                <CIcon name="cil-settings"/>
            </CLink>
            <CLink href="#" class="card-header-action btn-close" @click="modal=true; sendInfo(salle.libelle)">
                <CIcon color="red" name="cil-x-circle"/>
            </CLink>
            </footer>
            
          </CCardBody>
        </CCard>
      </CCol>
        </div>

<CModal :show.sync="modal"
        :no-close-on-backdrop="true"
        :centered="true"
        title="Modal title 2"
        size="xl"
        color="danger"
>

    <template #header>
        <h6 class="modal-title">Supprimer une salle</h6>
        <CButtonClose @click="modal = false" class="text-white"/>
    </template>

    Êtes-vous sûr de vouloir supprimer la salle {{selectedSalle.libelle}} ?
    <template #footer>
        <CButton @click="modal = false" >Annuler</CButton>
        <CButton @click="deleteSalle()" color="danger">Supprimer</CButton>
    </template>
</CModal>

 <!-- Modal components -->
                <CModal
                        :show.sync="modalEdit"
                        :no-close-on-backdrop="true"
                        :centered="true"
                        title="Modal title 2"
                        size="xl"
                        color="dark"
                >
                    <template #body-wrapper>
                        <div class="container-fluid">
                            <div class="row">
                                <div class="col-sm-6">

                                    <div class="form-group row" style="margin-top: 15px">
                                        <label class="col-md-3 col-form-label" for="libelle_salle">Libellé</label>
                                        <div class="col-md-9">
                                    <input v-model="selectedSalle.libelle" class="form-control" id="libelle_salle" type="text"
                                           name="libelle_salle" placeholder="Nom de la salle">
                                </div>
                                    </div>

                                    <div class="form-group row" style=" margin-top: 30px">
                                        <label class="col-md-3 col-form-label" for="capacite">Capacité</label>
                                        <div class="col-md-9">
                                            <input v-model="selectedSalle.capacite" class="form-control" id="capacite" type="number"
                                                name="capacite" value="0">
                                        </div>
                                    </div>

                                    <div class="form-group row" style=" margin-top: 30px">
                                        <label class="col-md-3 col-form-label" for="emplacement">Emplacement</label>
                                        <div class="col-md-9">
                                            <textarea v-model="selectedSalle.emplacement" class="form-control" id="emplacement" name="" rows="2"
                                                    placeholder="Emplacement de la salle de réunion..."></textarea>
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label class="col-md-3 col-form-label" for="emplacement">Norme PMR</label>
                                        <div class="col-md-9">
                                            <label class="c-switch c-switch-label c-switch-outline-primary">
                                                <input v-on:click="toggle()" class="c-switch-input" type="checkbox" checked=""><span
                                                    class="c-switch-slider" data-checked="✓" data-unchecked="✕"></span>
                                            </label>
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label class="col-md-3 col-form-label" for="emplacement">Equipements</label>
                                        <div class="col-md-9">
                                            <v-select multiple v-model="selectedSalle.equipement" label="libelle" :options="equipement" />
                                        </div>
                                    </div>

                                </div>

                            </div>
                        </div>

                    </template>

                    <template #header>
                        <h6 class="modal-title">Modifier une salle</h6>
                        <CButtonClose @click="modalEdit = false" class="text-white"/>
                    </template>
                    <template #footer>
                        <CButton @click="modalEdit = false" color="danger">Annuler</CButton>
                        <CButton @click="editSalle()" color="success">Enregistrer</CButton>
                    </template>
                </CModal>









        </div>

</template>

<script>
    import vSelect from 'vue-select'
    import 'vue-select/dist/vue-select.css';
    import swal from "sweetalert";
    import axios from "axios";

    export default {
        name: 'RechercheSalle',
        components: {
            vSelect
        },
        data() {
            return {
                salles: [],
                modal: false,
                modalEdit: false,
                selectedSalle:{},
                equipement: null,
            };
        },
        methods: {
            getJsonFile () {
                this.equipement = require('../../assets/JsonData/equipement.json')
            },
            async getAllSalle() {
                await this.$http.get("/api/salles/getAllMeetingRoom")
                    .then(response => {
                        if (response.status === 200) {
                            this.salles = response.data
                        }
                    })
            },
            async deleteSalle(){
                console.log(this.selectedSalle)
                await this.$http.post("/api/salles/deleteMeetingRoom", this.selectedSalle)
                    .then(response => {
                        if (response.status === 201) {
                            //this.salles = response.data
                            this.modal = false
                            swal("Succès", response.data.msg, "success");
                        }
                    })
            },
            async editSalle() {
                console.log(this.selectedSalle);
                this.selectedSalle.newlibelle = this.selectedSalle.libelle
                await this.$http.post("/api/salles/editMeetingRoom", this.selectedSalle)
                    .then(response => {
                        console.log(response)
                        if (response.status === 201) {
                            //this.salles = response.data
                            this.modalEdit = false
                            swal("Succès", response.data.msg, "success");
                        }
                        //console.log(response)
                    })
            },
            sendInfo(item) {
                this.selectedSalle.libelle = item;
            },
            sendInfoSalle(item) {
                this.selectedSalle = item;
            }
        },
        beforeMount() {
            this.getAllSalle()
            this.getJsonFile();
        },
    }

</script>

<style scoped>

</style>
